%global gitrev ac85819cc
%global buildfromsource 1

Name:		lulzbot-marlin-firmware
Version:	1.1.5.71
Release:	1%{?dist}
Epoch:		1
Summary:	Marlin firmware files for the Lulzbot family of 3D printers
# this uses the arduino cross-compiler, so the output is arch-independent
BuildArch:	noarch
# Firmware source includes BSD, MIT, ISC, GPLv2+, GPLv3+, LGPLv2+, and LGPLv3+ licensed files
# Resulting combination is GPLv3+.
License:	GPLv3+
URL:		https://code.alephobjects.com/diffusion/MARLIN/
# https://www.lulzbot.com/learn/tutorials/firmware-flashing-through-cura
#
# If we pull from git:
# git clone https://code.alephobjects.com/diffusion/MARLIN/marlin.git
# cd marlin
# git checkout ac85819cc
# cd ..
# mv marlin/ lulzbot-marlin-firmware-1.1.5.71/
# tar cfz lulzbot-marlin-firmware-1.1.5.71.tar.gz lulzbot-marlin-firmware-1.1.5.71/
Source0:	lulzbot-marlin-firmware-%{version}.tar.gz
# Work around https://gcc.gnu.org/bugzilla/show_bug.cgi?id=71873
# Should not be needed when avr-gcc 7.0.0 arrives
Patch1:		lulzbot-marlin-firmware-1.1.5.64-set-fno-move-loop-invariants.patch

BuildRequires:	arduino-core
BuildRequires:	git-core
Requires:	cura-lulzbot >= 2.6.69
# This is the best representation I could come up with for the bundled
# arduino bits and libraries
Provides:	bundled(arduino)
Provides:	bundled(arduino:LiquidCrystal)
Provides:	bundled(arduino:SPI)
Provides:	bundled(arduino:U8glib)

%description
%{summary}.

%global platform mega2560

%prep
%setup -q
%patch1 -p1 -b .nmli

%build
./build-lulzbot-firmware.sh 
# rename code in shell script assumes perl variant, we have util-linux variant
# this is more portable.
for f in build/*.hex; do mv "$f" "$(echo $f | cut -d '_' -f 1,3,5,6-)"; done
# for f in build/*.hex; do mv "$f" "$(echo $f | sed 's|6353ccb1f|6353ccb|g')"; done

%install
mkdir -p %{buildroot}%{_datadir}/cura-lulzbot/firmware/
install -Dpm0644 build/*.hex %{buildroot}%{_datadir}/cura-lulzbot/firmware/

pushd %{buildroot}%{_datadir}/cura-lulzbot/
mkdir resources
ln -s ../firmware resources/firmware
popd

%files
%doc README.md
%license LICENSE
%{_datadir}/cura-lulzbot/firmware/*
%{_datadir}/cura-lulzbot/resources/firmware

%changelog
* Wed Mar 14 2018 Tom Callaway <spot@fedoraproject.org> - 1:1.1.5.71-1
- update to 1.1.5.71

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.1.5.70-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Jan 17 2018 Tom Callaway <spot@fedoraproject.org> 1:1.1.5.70-1
- update to 1.1.5.70

* Wed Jan  3 2018 Tom Callaway <spot@fedoraproject.org> 1:1.1.5.64-1
- bump epoch and use new firmware tree (whee!)

* Thu Nov 23 2017 Miro Hrončok <mhroncok@redhat.com> - 21.08-2
- Rebuilt to get it to f27

* Mon Aug 14 2017 Tom Callaway <spot@fedoraproject.org> - 21.08-1
- update to 21.08
- make symlink for cura2 compat
- do not build firmware from source (still no idea why it does not work)

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 21.03-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 21.03-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Jan  4 2017 Tom Callaway <spot@fedoraproject.org> - 21.03-1
- update mini to 1.1.0.11

* Tue Nov 29 2016 Tom Callaway <spot@fedoraproject.org> - 21.00-2
- update mini to 1.1.0.10
- patch oliveoil* to build with gcc 6.2

* Fri Sep 30 2016 Tom Callaway <spot@fedoraproject.org> - 21.00-1
- update to 21.00 revisions
- drop patch merged upstream
- add TAZ6 moarstruder firmware

* Tue Sep  6 2016 Tom Callaway <spot@fedoraproject.org> - 20.03-2
- depend on cura-lulzbot
- do not own firmware dir (cura-lulzbot does)
- include README.md
- use smp_mflags
- add bundled provides
- add licensing comment
- update Gladiola to 1.1.0.9

* Wed Aug 31 2016 Tom Callaway <spot@fedoraproject.org> - 20.03-1
- update to firmware in cura-lulzbot 20.03

* Thu Jul 28 2016 Tom Callaway <spot@fedoraproject.org> - 20.01-1
- update to mini 1.1.0.5 f5e8154 (Gladiola)

* Tue Apr 12 2016 Tom Callaway <spot@fedoraproject.org> - 19.08-1
- initial package for lulzbot firmware (inspired a lot by Miro Hrončok's ultimaker2-marlin-firmware)
